Salesforce REST Apex app
===========================================

Allows invoking methods from Apex classes that have beed deployed to Salesforce and exposed as REST web services.

Installation and Usage
----------------------

Import the demo project into your workspace
Fill in all the values in /main/app/mule-app.properties

Run the project in Studio.
Each mule configuration file in this demo has a deploy metadata flow to add the apex class invoked in the other flows to your organization.
Before running other flow from a mule configuration file, please run first the deploy flow by choosing the .zip containing the corresponding apex class and put it in resources/in folder.

After running the [mapAccount,listAccount,dateTime,date]_rest_apex_deploy
The [mapAccount,listAccount,dateTime,date]_rest_apex_deploy_flow in deploy_apex.xml configuration file flow will run and will deploy the zip from /resources/in. 
That means that the Apex class declared in the .zip file will be deployed to you organization.

At this point you are ready to start using the other flows from the mule configuration file you ran [mapAccount,listAccount,dateTime,date]_rest_apex_deploy_flow. 
In each configuration file, you have 2 flows to call a get or a post method from the apex class you deployed.

1.get

Run the demo project and  in the browser hit `http://localhost:8081`, the result would be a website that consists of three operations (Get Date, Get DateTime, Get List Account). This will:

1.1) for the ListAccount it will return a list of accounts that the apex method queried, in json format

1.2) for DateTime it will return the current date containing the current year, month, day, hour, minute and second

1.3) for Date it will return the current date containing the current year, month and day

For calling the get method for MapAccount, put the getMapAccount.json in recources/in. The url for this apex class has 2 * symbols so the getMapAccount.json has 2 UrlParameters to replace the * symbols. It will return a map of <String,Account>

2.post

Put the JSON corresponding to the correct type(date.json for Date, dateTime.json for dateTime, listAccount.json for listAccount and mapAccount.json for mapAccount) in resources/in to execute a post operation
This will:

1) for the ListAccount it will insert the given accounts and return the account list

2) for the MapAccount it will return the <String,Account> map you given as input

3) for DateTime it will return the dateTime you given as input.
If you have * in your url, you must add urlParameters, each containing a value for an individual *. For example the accountMap apex class has in the url 2 *.
In the post method, the mapAccount.json has 2 UrlParameters to replace the value of each *.
In the `datetime_rest_apex_app.xml` configuration file, you can see how you can add request headers.
In the postDatetime flow, the CreateApexRequestHeaders.java is called to add to the payload the request headers.

4) for Date it will return the date you given as input

