/**
 * (c) 2003-2019 MuleSoft, Inc. The software in this package is published under the terms of the Commercial Free Software license V.1 a copy of which has been included with this distribution in the LICENSE.md file.
 */
package apex_demo;

import org.mule.api.MuleEventContext;
import org.mule.api.lifecycle.Callable;
import org.mule.api.transport.PropertyScope;
import org.mule.modules.salesforce.apex.rest.ApexRequestHeaders;

public class CreateApexRequestHeaders implements Callable {

	@Override
	public Object onCall(MuleEventContext eventContext) throws Exception {
		eventContext.getMessage().setProperty("someHeaders", createRequestHeaders(), PropertyScope.OUTBOUND);
		return eventContext.getMessage().getPayload();
	}
	
	public ApexRequestHeaders createRequestHeaders()
	{
		ApexRequestHeaders requestHeaders = new ApexRequestHeaders();
		requestHeaders.addHeader("headerKey1", "headerValue1");
		requestHeaders.addHeader("headerKey2", "headerValue2");
		
		requestHeaders.addCookie("cookieKey1", "CookieValue1");
		requestHeaders.addCookie("cookieKey2", "CookieValue2");
		return requestHeaders;
	}

}
